//The residual is calculated from the sum of squared residuals (SSR)
function SSR = calc_res2

//==============Read results==============
[Sx66,Sxx66,Sy66,Syy66]=get_result('Biax_66');
[Sx36,Sxx36,Sy36,Syy36]=get_result('Biax_36');
[Sx63,Sxx63,Sy63,Syy63]=get_result('Biax_63');


//==============Calculate Sum of Squared Residuals (RRS)==============
SqResid_x66=sum((Sx66-Sxx66).^2,1);
SqResid_y66=sum((Sy66-Syy66).^2,1);
SqResid_x36=sum((Sx36-Sxx36).^2,1);
SqResid_y36=sum((Sy36-Syy36).^2,1);
SqResid_x63=sum((Sx63-Sxx63).^2,1);
SqResid_y63=sum((Sy63-Syy63).^2,1);

SR=[SqResid_x66 SqResid_y66 SqResid_x36 SqResid_y36 SqResid_x63 SqResid_y63];
SSR=nansum(SR);//Sum of values ignoring NAN's

sim=mopen('simulated_stress_result.dat', 'a')
mfprintf(sim,'\n ------------------------------- \n');
mclose(sim);

endfunction
