//The residual is calculated from the "NORMALIZED" difference between Exp and Simu data (Normalized Sum of Absolute Differences(NSAD)).

function SSR = calc_res4

//==============Read results==============
[Sx66,Sxx66,Sy66,Syy66]=get_result('Biax_66');
[Sx36,Sxx36,Sy36,Syy36]=get_result('Biax_36');
[Sx63,Sxx63,Sy63,Syy63]=get_result('Biax_63');


//==============Calculate Sum of Squared Residuals (RRS)==============
SqResid_x66=sum((Sx66-Sxx66)./Sx66,1);
SqResid_y66=sum((Sy66-Syy66)./Sy66,1);
SqResid_x36=sum((Sx36-Sxx36)./Sx36,1);
SqResid_y36=sum((Sy36-Syy36)./Sy36,1);
SqResid_x63=sum((Sx63-Sxx63)./Sx63,1);
SqResid_y63=sum((Sy63-Syy63)./Sy63,1);

SR=[abs(SqResid_x66) abs(SqResid_y66) abs(SqResid_x36) abs(SqResid_y36) abs(SqResid_x63) abs(SqResid_y63)];
SSR=nansum(SR);//Sum of values ignoring NAN's

sim=mopen('simulated_stress_result.dat', 'a')
mfprintf(sim,'\n ------------------------------- \n');
mclose(sim);

endfunction
