//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// PARAMETERS TO BE SET BY THE USER (UPPER CASE COMMENTS)
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

//mclose("all"), cd("..")

clear


Ti=clock(); tic;
mfprintf(%io(2),'Computation started at %u h %u min.\n\n',Ti(4),Ti(5));

global counter
global pop_size


global job_name
job_name=cell(3,1);
job_name(1).entries="Biax_66";
job_name(2).entries="Biax_36";
job_name(3).entries="Biax_63";


global optim_algo
optim_algo=5;

// optim algo=1 -> quasi-Newton
// optim_algo=2 -> Levenberg-Marquardt
// optim_algo=3 -> Newton


//->> hyperelastic parameters (Fung-orthotropic).. initial values.
b1111=9.2;
b1122=3.7;//-->> always zero
b2222=20;
b1133=3.7;//-->> always zero
b2233=3.7;// -->> always zero
b3333=2;
b1212=3.7;
b1313=3.7;
b2323=2;
c=0.015;
//D=0; -->> always zero
Para_min = [0.01 0 0.01 0 0 0.01 0.01 0.01 0.01 0.0002];//[0.0001 -1 0.01 -1 -1 0.0001 0.0001 0.0001 0.0001 0.0002];
Para_max = [1 0 1 0 0 1 1 1 1 0.005];//[1 1 1 1 1 2 2 2 2 0.005]///[2 1 2 1 1 2 2 2 2 0.005];
//xinitial = [b1111 b2222 b3333 b1212 b1313 b2323 c] ;
//xmin = Para_min;
//xmax = Para_max;


// Initialization: nothing to be set by the user
dossier = "D:\Mazin Sirry\Documents\_Science PhD\Inverse modelling\inf 0d" ; // rootfolder -> to modify
global run_folder ;
run_folder = strcat([dossier,"\RUN"]);
mkdir(run_folder) ;
copyfile(dossier+"\SOURCES\Python" ,  dossier+"\RUN");
copyfile(dossier+"\DATA\", dossier+"\RUN") ;    
cd (run_folder) ;// make RUN the current dir
getd(dossier+"\SOURCES")// Load all .sci files (functions) that contained in the folder SOURCE, the make them available for calling.

fid=mopen('logout.txt','a');
mfprintf(fid,'\n Computation started at %u h %u min.\n\n',Ti(4),Ti(5));
mclose(fid);


//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// PROGRAM CORE
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


// check if it is helpful
//writePY;//call writePY.sci function (Function that generates the main python file)
//system(strcat('gnome-terminal --working-directory=',run_folder, ' -e ''abaqus python ecouteur.py' , ''' &'));


// Normalise the parameter vector .. we can always get the original 

//global xnorm ;
//xnorm = xinitial ;
//xinitial = xinitial./xnorm ;
//xmin = xmin./xnorm ;
//xmax = xmax./xnorm ;


if optim_algo==1 then
    //////////////////////
    // Quasi Newton
    /////////////////////

    // optim parameters
    binf=xmin;
    bsup=xmax;
    nap=10; //max nb of calls of cost function (default = 100)
    iter=100; //max iter allowed (default = 100)
    epsg=0; //threshold on grad norm (default = 0)
    epsf=0.001; //threshold controlling degressing of f (default = 0)
    epsx=0.001; //threshold controlling degressing of x (default = 0)
    algo="qn"; // qn=quasi-Newton with BFGS (default), gc=limited memory BFGS, nd=non-differentiable

    // Optimisation loop
    //test=cost_function(xinitial)
    //[fval, xopt, gradopt]=optim(cost_function, 'b', xmin, xmax, xinitial, algo, "ar", nap, iter, epsg, epsf, epsx)
    //[fval, xopt, gradopt]=optim(cost_function, 'b', xmin, xmax, xinitial, algo, "ar", nap)
    [fval, xopt, gradopt]=optim(cost_function_optim, "b", binf, bsup, xinitial)//, algo, "ar", nap, iter, epsg, epsf, epsx);
    //[fval, xopt, gradopt]=optim(cost_function, xinitial);

elseif optim_algo==2 then
    //////////////////////
    // Levenberg-Marquardt
    /////////////////////
    
    // optim parameters
    m=7; // number of function. must be greater than or equal to No. of parameters.
    ftol=1e-8; // (default=1e-8)
    xtol=1e-8; // (default=1e-8)
    gtol=1e-5; // (default=1e-5)
    maxfev=3; // max number of fct calls (default=1000)
    epsfcn=0; // (default=0)
    factor1=100; // (default=100)

    // Optimisation loop
    [xopt, fval, info]=lsqrsolve(xinitial, cost_function_lsqrsolve, m);//, maxfev)
    
elseif optim_algo==3 then
    //////////////////////
    // Newton
    /////////////////////
    
    // optim parameter
    tol=1e-10; //precision tolerance: relative error between x and the solution is at most tol. (default=1.d-10)
    
    // optimisation loop
    [xopt, fval, info]=fsolve(xinitial, cost_function_fsolve, tol)

elseif optim_algo==4 then
    //////////////////////
    // fmincon: Constrained, nonlinear, multivariable
    /////////////////////
    
    // optim parameters
    //[x,fval,exitflag,output,lambda,grad,hessian] = fmincon(fun,x0,A,b,Aeq,beq,lb,ub,nonlcon,options)
    
    A=[]; // a (nil x n) matrix of doubles, where n is the number of variables and nil is the number of linear inequalities. If A==[] and b==[], it is assumed that there is no linear inequality constraints. If (A==[] & b<>[]), fmincon generates an error (the same happens if (A<>[] & b==[]))
    b=[]; // a (nil x 1) matrix of doubles, where nil is the number of linear inequalities.
    Aeq=[]; // a (nel x n) matrix of doubles, where n is the number of variables and nel is the number of linear equalities. If A==[] and b==[], it is assumed that there is no linear equality constraints. If (Aeq==[] & beq<>[]), fmincon generates an error (the same happens if (Aeq<>[] & beq==[])).
    beq=[]; // (default=1e-5)
    lb=xmin;//a nx1 or 1xn matrix of doubles, where n is the number of variables. The lower bound for x. If lb==[], then the lower bound is automatically set to -inf.
    ub=xmax;//a nx1 or 1xn matrix of doubles, where n is the number of variables. The upper bound for x. If lb==[], then the upper bound is automatically set to +inf.
function [cc,ceq]=confun(x)
    cc=[];
    ceq=[];
endfunction
options=optimset("GradConstr","off");
    // Optimisation loop
    [x,fval,exitflag,output,lambda,grad,hessian] = fmincon(cost_function_fmincon,xinitial,A,b,Aeq,beq,lb,ub,confun,options);
    
    
elseif optim_algo==5 then
    //////////////////////
    // Genetic Algo
    /////////////////////
    
    // optim parameter
    pop_size=100;//the size of the population of individuals (default value: 100).
    counter=pop_size;
    nb_generation=10; //the number of generations (i.e. number of iterations) to be computed (default value: 10).
    p_mut=0.5;//the mutation probability (default value: 0.1).
    p_cross=0.7;//the crossover probability (default value: 0.7).
    NbCouples=50;// the number of couples which will be selected so as to perform the crossover and mutation (default value: 100).
    pressure=0.05; //the value the efficiency of the worst individual (default value: 0.05)
    Log=%T;//if %T, we will display to information message during the run of the genetic algorithm.
// Parameters to adapt to the shape of the optimization problem
    ga_params = init_param();
    ga_params = add_param(ga_params,"dimension",10)
    ga_params = add_param(ga_params,"minbound",Para_min');
    ga_params = add_param(ga_params,"maxbound",Para_max');
    ga_params = add_param(ga_params,"beta",0);
    ga_params = add_param(ga_params,"delta",0.1);
// Parameters to fine tune the Genetic algorithm. 
// All these parameters are optional for continuous optimization
// If you need to adapt the GA to a special problem ..
    ga_params = add_param(ga_params,"init_func",init_ga_default);
    ga_params = add_param(ga_params,"crossover_func",crossover_ga_default);
    ga_params = add_param(ga_params,"mutation_func",mutation_ga_default);
    ga_params = add_param(ga_params,"codage_func",coding_ga_identity);
    ga_params = add_param(ga_params,"selection_func",selection_ga_elitist);
    ga_params = add_param(ga_params,"nb_couples",NbCouples);
    ga_params = add_param(ga_params,"pressure",pressure);
// optimisation loop
    [pop_opt,fobj_pop_opt,pop_init,fobj_pop_init] = optim_ga(cost_function_ga_rev01,pop_size,nb_generation,p_mut,p_cross,Log,ga_params);

    
    fid=mopen('costf.txt','a');
    mfprintf(fid,"Optimum population =\n %f %f %f %f %f %f %f %f %f %f \n",pop_opt');
    mclose(fid);
end




// returning the parameters to its original "non-normalized" values after optimisation is complete.
//xopt = xopt.*xnorm 


//write_fminsearch(xresultat,fval, t01,xinitial,output,exitflag);


t0=toc();
h0=floor(t0/3600);
m0=floor((t0-h0*3600)/60);
s0=round(t0-m0*60-h0*3600);
mfprintf(%io(2),'\n The computation took %u heures, %u minutes et %u secondes.\n',h0,m0,s0);

//endfunction
